#line 14 "directory.nw"
#include <sys/types.h>
#include <sys/param.h>
#include <sys/stat.h>
#include <unistd.h>
#include <dirent.h>
#include <errno.h>

#define maxpathlen()		MAXPATHLEN
#define dirent_d_name(dp)	((struct dirent *)dp)->d_name

#if defined(_WIN32) && !defined(__CYGWIN__)
# define mkdir(d,m)		mkdir(d)
#endif

#line 34 "directory.nw"
static inline int
exist_d(const char *path)
{
    struct stat st;
    return stat(path, &st) == 0 ? st.st_mode & S_IFDIR
	: (errno == ENOTDIR || errno == ENOENT) ? 0 : -1;
}

static inline int
exist_f(const char *path)
{
    struct stat st;
    return stat(path, &st) == 0 ? !(st.st_mode & S_IFDIR)
	: (errno == ENOTDIR || errno == ENOENT) ? 0 : -1;
}

#line 55 "directory.nw"
static inline int
rename_d(const char *from, const char *to)
{
    struct stat st;
    if ( stat(from, &st) == 0 )
    {
	if ( st.st_mode & S_IFDIR )
	    return rename(from, to);
	errno = ENOTDIR;
    }
    return -1;
}

static inline int
rename_f(const char *from, const char *to)
{
    struct stat st;
    if ( stat(from, &st) == 0 )
    {
	if ( !(st.st_mode & S_IFDIR) )
	    return rename(from, to);
	errno = EISDIR;
    }
    return -1;
}

#line 86 "directory.nw"
static inline int
modtime(const char *path)
{
    struct stat st;
    return stat(path, &st) == 0 ? st.st_mtime : -1;
}
