#line 41 "spaces.nw"
#if 0
typedef struct search_space SearchSpace; /* already declared in heap.h */
#endif
#if !COPY_SEARCH_SPACE
typedef struct script Script;
#endif

struct search_space {
    NodeInfo	*info;
#if !COPY_SEARCH_SPACE
    SearchSpace	*root;		/* pointer to root space */
    SearchSpace	*parent;	/* parent space */
    SearchSpace	*active;	/* active space (valid only on root) */
    Script	*script;	/* saved local bindings */
#endif
};

extern const SearchSpace global_space;

#line 107 "spaces.nw"
#if !COPY_SEARCH_SPACE
# define is_local_space(space) ((space)->root == regs.ss->root)
#else
# define is_local_space(space) ((space) == regs.ss)
#endif

#line 125 "spaces.nw"
#if !COPY_SEARCH_SPACE
typedef struct script_rec {
    word	 *addr;		/* address to be updated */
    word	 inInfo;	/* info vector inside space */
    word	 outInfo;	/* info vector outside space */
    unsigned int ofs;		/* offset within node */
    word	 inVal;		/* value inside space */
    word	 outVal;	/* value outside space */
} ScriptRec;

struct script {
    NodeInfo  *info;
    unsigned  length;
    ScriptRec data[1];
};
#endif

#line 291 "spaces.nw"
#if !COPY_SEARCH_SPACE
extern void leave_context(void);
#else
# define leave_context()  /* empty */
#endif

#line 341 "spaces.nw"
extern void new_search_space(unsigned int n_regs);

#line 370 "spaces.nw"
#if !COPY_SEARCH_SPACE
extern bool inject_search_space(SearchSpace *);
#else
# define inject_search_space(space)  false
#endif

#line 407 "spaces.nw"
#if !COPY_SEARCH_SPACE
extern void save_search_space(unsigned int n_regs);
#else
# define save_search_space(n_regs)  /* empty */
#endif

#line 473 "spaces.nw"
extern void discard_search_space(void);

#line 495 "spaces.nw"
#if !COPY_SEARCH_SPACE
extern void restore_search_space(SearchSpace *space);
#else
# define restore_search_space(space)  (regs.ss = (space))
#endif

#line 525 "spaces.nw"
extern Node *copy_graph(unsigned int n_regs, Node *graph, SearchSpace *space);

