#line 67 "threads.nw"
#ifdef CURRY_RTS
enum { THREAD_TAG, SURROGATE_TAG };

# if 0
typedef union thread_node *ThreadQueue; /* already declared in heap.h */
# endif

# define THREAD_INFO \
    NodeInfo	     *info; \
    unsigned int     id;		/* (unique) thread id */ \
    ThreadQueue	     next;		/* link to next thread of queue */

struct thread_state {
    THREAD_INFO
    int		     reason;		/* reason for suspension */
    Label	     ip;		/* next instruction to be executed */
    ExceptionFrame   *efp;		/* pointer to exception frame */
    Node	     **ds_base;		/* base address of stack */
    unsigned int     ds_size;		/* size of data stack (segment) */
    Node	     *ds;		/* saved data stack */
};

struct thread_surrogate {
    THREAD_INFO
    ThreadQueue	     thd;		/* pointer to the "real" thread */
    ThreadQueue	     link;		/* ring of surrogates for the thread */
};

union thread_node {
    struct thread_state	    t;
    struct thread_surrogate s;
};
#endif

#line 135 "threads.nw"
#ifdef CURRY_RTS
enum suspend_reason {
    None,			/* interrupted */
    Yield,			/* rescheduled due non-determinism */
    Delay,			/* suspended due to unbound variable */
    Eval			/* suspended due to locked application */
};
#endif

#line 172 "threads.nw"
extern void start_thread(unsigned int n, Label l);
DECLARE_LABEL(extern, stop_thread);
DECLARE_LABEL(extern, suspend_thread);
DECLARE_LABEL(extern, delay_thread);
DECLARE_LABEL(extern, yield_thread);
DECLARE_LABEL(extern, yield_delay_thread);
extern Label activate_threads(ThreadQueue wq, Label l);
extern void wake_threads(ThreadQueue wq);
extern ThreadQueue join_queues(ThreadQueue tq1, ThreadQueue tq2);

#line 200 "threads.nw"
extern void save_continuation(unsigned int n_regs);
#if !COPY_SEARCH_SPACE
extern void restore_continuation(unsigned int n_regs, Label l, ThreadQueue rq);
#else
extern void restore_continuation(Label l, ThreadQueue rq);
# define restore_continuation(n_regs, l, rq) restore_continuation(l, rq)
#endif
extern Label resume_continuation(Label l, ThreadQueue rq);

